-- RBT-TEST - проверка подключения к БД
-- Проверка подключения к БД с меткой и CCR
--
\i 'support/init.sql'
\i 'support/init-config-tools.sql'
\i 'support/support_functions.sql'
--
-- Подключаемся как администратор кластера
\connect mtest postgres
--
-- Настройка мандатных атрибутов для тестирования
--
-- Устанавливаем мандатную метку кластера
MAC LABEL ON CLUSTER IS '{3,0}';
--
-- Устанавливаем признак MAC CCR кластера
MAC CCR ON CLUSTER IS ON;
--
-- Устанавливаем метку базы данных
MAC LABEL ON DATABASE mtest IS '{3,0}';
--
-- Устанавливаем признак MAC CСR у базы данных
MAC CCR ON DATABASE mtest IS ON;
--
-- Устанавливаем параметр ac_ignore_socket_maclabel
SELECT ac_change_param('ac_ignore_socket_maclabel', true);
--
-- Проверяем значение параметра
SELECT * FROM advanced_waiting(query := 'SELECT 
                                               case 
                                                   when setting in (''on'', ''yes'', ''true'') then 1
                                               	else 0
                                               end case
                                         FROM pg_settings WHERE name = ''ac_ignore_socket_maclabel'';', 
                               expected_result := 1,
                               label := 'начальная проверка ac_ignore_socket_maclabel');
--
-- Проверяем соединение от имени суперпользователя
-- Ожидается успешное соединение
\connect mtest postgres
--
-- Проверяем соединение от имени пользователя u_0_00
-- Ожидается отказ в доступе
\connect mtest u_0_00