-- RBT-TEST - Проверка механизма уведомлений
--
\i 'support/init.sql'
--
-- Проверка передачи сообщения на одном уровне
\! psql -h localhost -p 6000 -d mtest -U u_0_00 -c 'BEGIN; LISTEN ch1; COMMIT; SELECT pg_sleep(6); LISTEN ch1;' > /tmp_test/listen1.out 2>&1 &
\! sleep 2
\! psql -h localhost -p 6000 -d mtest -U u2_0_00 -c "Notify ch1, 'Тест #1';" > /dev/null
--
-- Проверка передачи сообщения "снизу-вверх"
\! psql -h localhost -p 6000 -d mtest -U u_2_11 -c 'BEGIN; LISTEN ch2; COMMIT; SELECT pg_sleep(6); LISTEN ch2;' > /tmp_test/listen2.out 2>&1 &
\! sleep 2
\! psql -h localhost -p 6000 -d mtest -U u_1_01 -c "Notify ch2, 'Тест #2';" > /dev/null
--
-- Проверка передачи сообщения "сверху-вниз"
\! psql -h localhost -p 6000 -d mtest -U u_1_10 -c 'BEGIN; LISTEN ch3; COMMIT; SELECT pg_sleep(6); LISTEN ch3;' > /tmp_test/listen3.out 2>&1 &
\! sleep 2
\! psql -h localhost -p 6000 -d mtest -U u_1_11 -c "Notify ch3, 'Тест #3';" > /dev/null
--
\! sleep 9
--
-- Результат просматривается в файле для синхронизации вывода
--
-- Ожидается уведомление
--
\! sed -n 's/PID\ [0-9]*/PID/p' /tmp_test/listen1.out
--
-- Ожидается уведомление
--
\! sed -n 's/PID\ [0-9]*/PID/p' /tmp_test/listen2.out
--
-- Не ожидается уведомление
--
\! grep -E 'LISTEN|PID' /tmp_test/listen3.out
--
\i 'support/done.sql'
