#!/bin/bash
#
# Готовим библиотеку astra_mem_chek.so
cp ./support/astra_mem_check.so /tmp/astra_mem_check.so
#
# Параметры кластера
VERSION=$1
NAME=$2
PORT=$3
RAND_PARAM=$4
#
# Останавливаем вспомогательный кластер
pg_ctlcluster $VERSION $NAME stop
#
sleep 1
# Перезапускаем вспомогательный кластер с библиотекой astra_mem_chek.so
# Важно, чтобы значение "ac_audit_mode" задавалось первее, чем у "logging_collector"
sudo su postgres -c 'LD_PRELOAD="/tmp/astra_mem_check.so" \
					/usr/lib/postgresql/15/bin/postgres \
							-p '$PORT' \
							-D /var/lib/postgresql/'$VERSION'/'$NAME' \
							-c config_file=/etc/postgresql/'$VERSION'/'$NAME'/postgresql.conf \
							-c hba_file=/etc/postgresql/'$VERSION'/'$NAME'/pg_hba.conf \
							-c ac_audit_mode="none" \
							-c logging_collector=off \
							-c ssl=off \
							-c ac_rand_free_memory='$RAND_PARAM' > /dev/null 2>&1' &
sleep 3
# Создаём временную таблицу с секретными данными
psql -p $PORT -d template1 -U postgres -c "CREATE TEMP TABLE tbl AS SELECT text('Special data. Top secret!');" -c "\! sleep 2" > /dev/null
#
# Останавливаем вспомогательный кластер
pg_ctlcluster $VERSION $2 stop > /dev/null 2>&1
#
# Ищем секретную запись
if (($(grep -ac "Special data. Top secret" /tmp/out.txt)>0)); then
	echo "Секретная запись найдена!"
else
	echo "Секретная запись не найдена!"
fi
#
# Возвращаем вспомогательный кластер обратно в работу
pg_ctlcluster $VERSION $2 start > /dev/null 2>&1
#
# Удаляем временные файлы
rm -f /tmp/out.txt
rm -f /tmp/mem_check.c
rm -f /tmp/astra_mem_check.so
