#!/usr/bin/perl
# Аргументы: <pg version> <arguments for postgres binary>

# Пример запуска: "sudo execaps -c 0x400 -- perl ./postgres_with_caps.pl 11 -V"
# PARSEC_CAP_CAP - 0x00400 - Позволяет процессу устанавливать любой непротиворечивый набор привилегий для себя.

use strict;
use warnings;
use PgCommon;
use IPC::Run;

sub change_user_to_postgres {
    # Код частично взят из файла TestLib.pm из функции exec_as() в postgresql-common
    my $uid = getpwnam "postgres";
    defined($uid) or die "Target user '$_[0]' does not exist";
    change_ugid($uid, (getpwuid $uid)[3]);  # Внутри вызывается prctl_set_keepcaps()
    die "changing euid: $!" if $> != $uid;
}

my $pg_version = $ARGV[0];
my $args = join(' ', @ARGV[1..$#ARGV]);
my $caps = "0x100D3C";

change_user_to_postgres;

# Для проверки:
# IPC::Run::run("execaps -c $caps -- bash -c 'id && pscaps 0 && echo $args'");

IPC::Run::run("execaps -c $caps -- /usr/lib/postgresql/$pg_version/bin/postgres $args");
